/*
 * Copyright (c) 2004-2005 Northwestern University.
 *                         NuCAD Group.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 * common.h - Common things.
 *
 * Authors: Jia Wang, jwa112@ece.northwestern.edu
 *
 */

#ifndef COMMON_H
#define COMMON_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <assert.h>
#include <math.h>

#ifdef __GNUC__
#define _vsnprintf vsnprintf
#define _strnicmp strncasecmp
#define _stricmp strcasecmp
#endif // __GNUC__

#ifdef _MSC_VER
// turn off warning 4786
//	identifier was truncated to '255' characters in the debug information
#pragma warning(disable: 4786)
#endif // _MSC_VER

#include <list>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <stdexcept>
#include <functional>
#include <algorithm>
#include <utility>

// you can use /Za instead for VC6
#if _MSC_VER < 1300
	#define for if (0) ; else for
#endif

namespace misc
{

typedef const char *cstr_t;

template <class T>
struct identity : std::unary_function<T, T>
{
	const T &operator () (const T &v) const {return v;}
}; // struct identity

} // namespace misc

#endif // COMMON_H
